Core - Bug # 23069

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)

Status: Resolved Priority: Should have
Author: Jerome Schneider Category: Performance
Created: 2010-07-02 Assigned To:

Updated: 2015-01-24 Due date:

TYPO3 Version: 6.2

PHP Version: 5.2

Complexity:

Is Regression: No

Sprint Focus:

Subject: Bottleneck in t3lib_tcemain

Description

| think | spotted a perf issue in the TYPO3 code, slowing processes down in backend, when recursively copying page-trees with
contents.

The code | take here as a reference is the one of release 4.4.0

t8lib/class.t3lib_tcemain.php:1008: method fillinFieldArray()

line 1056: There's a loop thru all the fields of all the tables

line 1111: for most of the fields (switch default) we call $this->checkValue()
line 1273: checkValue() calls $this->recordinfo() for the field

line 5981: recordInfo() executes a SQL query to get values for the field

As a result: for each page copied, for each table in TCA, for each field (most of them, the ones that are not system) in this table,
there's an SQL query executed.

Even worst news: recordInfo() executes the SQL query using the given id. In some cases (and always when copying pages) the id is
equals to something like NEWabcdef (that is, non numerical, and obviously not in database). Problem is, recordinfo() doesn't care
about that, and executes the SQL query doing an intval() on the given id, resulting in a SQL query fetching values for uid='0" (which
does not make sense).

In a structure where PHP and MySq| are on the same server, it might not hurt much, but when SQL and PHP are on dedicated
servers, network latency makes it incredibly slow (like minutes to copy pagetree containing 3~4 pages with some content elements)

(issue imported from #M14963)

History

#1 - 2010-07-02 10:59 - Jerome Schneider

Original list message:
http://lists.typo3.org/pipermail/typo3-dev/2010-June/040884.html

#2 - 2011-08-02 18:10 - Xavier Perseguers
- Target version changed from 4.6.0-beta1 to 4.6.0-beta2

#3 - 2011-08-30 15:54 - Xavier Perseguers
http://lists.typo3.org/pipermail/typo3-dev/2010-June/040884.html

- Target version changed from 4.6.0-betaZ2 to 4.6.0-beta3

#4 - 2011-09-20 15:39 - Oliver Hader

- Target version changed from 4.6.0-beta3 to 4.6.0-RC1

#5 - 2011-10-11 16:51 - Xavier Perseguers
- Target version changed from 4.6.0-RC1 to 4.6.0

#6 - 2011-10-25 23:44 - Chris topher
- Target version changed from 4.6.0 to 4.6.1

#7 - 2011-11-30 20:06 - Chris topher
- Target version changed from 4.6.1 to 4.6.2

#8 - 2011-12-26 21:33 - Steffen Gebert

- Target version deleted (4.6.2)

Speeding this up would be very good, of course...

#9 - 2014-01-20 17:25 - Ingo Schmitt
- Is Regression set to No

Problem is still existing in 6.2 dev

#10 - 2014-01-20 17:25 - Ingo Schmitt

- Category set to Performance

- Target version set to 6.2.0

- TYPO3 Version changed from 4.3 to 6.2

#11 - 2014-01-20 17:25 - Ingo Schmitt
- Parent task set to #55065

#12 - 2015-01-24 15:57 - Mathias Schreiber

- Status changed from Accepted to Resolved

fixed with the static fieldinfo cache

#13 - 2015-01-24 22:31 - Simon Schaufelberger

Mathias, can you reference another issue or something where this is fixed?
